package org.mercury_im.messenger.core;

import org.mercury_im.messenger.core.util.ThreadUtils;

import javax.inject.Inject;
import javax.inject.Named;

import io.reactivex.Scheduler;
import lombok.Getter;

public class SchedulersFacade {

    @Getter
    private final Scheduler io;
    @Getter
    private final Scheduler ui;
    @Getter
    private final Scheduler newThread;

    @Inject
    public SchedulersFacade(@Named(value = ThreadUtils.SCHEDULER_IO) Scheduler io,
                            @Named(value = ThreadUtils.SCHEDULER_UI) Scheduler ui,
                            @Named(value = ThreadUtils.SCHEDULER_NEW_THREAD) Scheduler newThread) {
        this.io = io;
        this.ui = ui;
        this.newThread = newThread;
    }
}
