package org.mercury_im.messenger.core.di.module;

import org.mercury_im.messenger.core.data.repository.AccountRepository;
import org.mercury_im.messenger.core.util.ThreadUtils;
import org.mercury_im.messenger.core.viewmodel.accounts.AccountsViewModel;
import org.mercury_im.messenger.core.viewmodel.accounts.LoginViewModel;
import org.mercury_im.messenger.core.xmpp.MercuryConnectionManager;

import javax.inject.Named;
import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import io.reactivex.Scheduler;

@Module
public class ViewModelModule {

    @Provides
    @Singleton
    static LoginViewModel provideLoginViewModel(MercuryConnectionManager connectionManager,
                                                AccountRepository accountRepository,
                                                @Named(ThreadUtils.SCHEDULER_IO) Scheduler ioScheduler,
                                                @Named(ThreadUtils.SCHEDULER_UI) Scheduler uiScheduler) {
        return new LoginViewModel(connectionManager, accountRepository, ioScheduler, uiScheduler);
    }

    @Provides
    @Singleton
    static AccountsViewModel provideAccountsViewModel(MercuryConnectionManager connectionManager,
                                                      AccountRepository accountRepository,
                                                      @Named(ThreadUtils.SCHEDULER_IO) Scheduler ioScheduler,
                                                      @Named(ThreadUtils.SCHEDULER_UI) Scheduler uiScheduler) {
        return new AccountsViewModel(connectionManager, accountRepository, ioScheduler, uiScheduler);
    }
}
